# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-JSON-MaybeXS
Summary:	Use Cpanel::JSON::XS with a fallback to JSON::XS and JSON::PP
Version:	1.004008
Release:	2.%{__distinit}%{__distvers}
License:	GPL-1.0-or-later OR Artistic-1.0-Perl
URL:		https://metacpan.org/release/JSON-MaybeXS
Source0:	https://cpan.metacpan.org/modules/by-module/JSON/JSON-MaybeXS-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(Text::ParseWords)
# Dependencies of bundled ExtUtils::HasCompiler
BuildRequires:	perl(Config)
BuildRequires:	perl(DynaLoader)
BuildRequires:	perl(ExtUtils::Mksymlists)
BuildRequires:	perl(File::Basename)
BuildRequires:	perl(File::Spec::Functions)
BuildRequires:	perl(File::Temp)
# Module Runtime
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(constant)
%if 0%{?fedora} > 36 || 0%{?rhel} > 9
BuildRequires:	perl(Cpanel::JSON::XS) >= 4.38
BuildRequires:	perl(experimental)
%else
BuildRequires:	perl(Cpanel::JSON::XS) >= 2.3310
%endif
BuildRequires:	perl(Exporter)
BuildRequires:	perl(if)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(strict)
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(JSON::PP) >= 2.27300
BuildRequires:	perl(JSON::XS) >= 3.0
BuildRequires:	perl(Test::More) >= 0.88
BuildRequires:	perl(Test::Needs) >= 0.002006
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif
%if 0%{?fedora} > 36 || 0%{?rhel} > 9
Requires:	perl(Cpanel::JSON::XS) >= 4.38
Requires:	perl(experimental)
%else
Requires:	perl(Cpanel::JSON::XS) >= 2.3310
%endif

%description
This module first checks to see if either Cpanel::JSON::XS or JSON::XS
is already loaded, in which case it uses that module. Otherwise it tries
to load Cpanel::JSON::XS, then JSON::XS, then JSON::PP in order, and
either uses the first module it finds or throws an error.

It then exports the "encode_json" and "decode_json" functions from the
loaded module, along with a "JSON" constant that returns the class name
for calling "new" on.

If you're writing fresh code rather than replacing JSON.pm usage, you
might want to pass options as constructor args rather than calling
mutators, so we provide our own "new" method that supports that.

%prep
%setup -q -n JSON-MaybeXS-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes README
%{perl_vendorlib}/JSON/
%{_mandir}/man3/JSON::MaybeXS.3*

%changelog
* Tue Aug 13 2024 Paul Howarth <paul@city-fan.org> - 1.004008-2
- Fix runtime dependency on Cpanel::JSON::XS 4.38 (rhbz#2304277)

* Sun Aug 11 2024 Paul Howarth <paul@city-fan.org> - 1.004008-1
- Update to 1.004008
  - Improved boolean testing

* Sun Aug  4 2024 Paul Howarth <paul@city-fan.org> - 1.004007-1
- Update to 1.004007
  - is_bool() now recognizes core booleans (perl 5.36+); note that JSON::PP
   4.11 and Cpanel::JSON::XS 4.38 are required to properly encode them

* Sun Apr 30 2023 Paul Howarth <paul@city-fan.org> - 1.004005-1
- Update to 1.004005
  - to_json and from_json are now documented (GH#2)

* Tue Sep 20 2022 Paul Howarth <paul@city-fan.org> - 1.004004-1
- Update to 1.004004
  - Slight speed optimization for is_bool()
- Use SPDX-format license tag
- Use %%license unconditionally

* Fri Nov 13 2020 Paul Howarth <paul@city-fan.org> - 1.004003-1
- Update to 1.004003
  - Fix another test that fails when JSON::XS is installed, but below version
    3.0

* Mon May 18 2020 Paul Howarth <paul@city-fan.org> - 1.004002-1
- Update to 1.004002
  - Fix test that fails when JSON::XS is installed, but below version 3.0
    (CPAN RT#132578)

* Sat May  2 2020 Paul Howarth <paul@city-fan.org> - 1.004001-1
- Update to 1.004001
  - Document when is_bool became available
  - Now favouring Cpanel::JSON::XS over JSON::XS in more situations (the former
    is always added to prereqs when a compiler is available, although JSON::XS
    is still used at runtime if new enough and Cpanel::JSON::XS is not
    installed); this makes boolean handling more predictable and consistent
- Package LICENSE file

* Thu Jun  6 2019 Paul Howarth <paul@city-fan.org> - 1.004000-5
- Perl 5.30 rebuild

* Fri Apr 20 2018 Paul Howarth <paul@city-fan.org> - 1.004000-1
- Update to 1.004000
  - Added true and false subs so they can be used via JSON::MaybeXS rather than
    only JSON() exported sub

* Mon Jan 29 2018 Paul Howarth <paul@city-fan.org> - 1.003010-1
- Update to 1.003010
  - Use bundled ExtUtils::HasCompiler rather than ExtUtils::CBuilder to detect
    compiler availability
  - Clarify exported JSON in documentation
- This release by HAARG → update source URL

* Fri Jun 16 2017 Paul Howarth <paul@city-fan.org> - 1.003009-2
- Drop support for EOL distributions prior to F-13
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section
  - Drop workaround for building with Test::More < 0.88

* Mon Feb 27 2017 Paul Howarth <paul@city-fan.org> - 1.003009-1
- Update to 1.003009
  - Fix tests to no longer rely on . being in @INC (CPAN RT#120404)
- Update patch for building with Test::More < 0.88

* Mon Oct  3 2016 Paul Howarth <paul@city-fan.org> - 1.003008-1
- Update to 1.003008
  - Added an INSTALLATION section to documentation, to clarify the use of
    dynamic prerequisites in Makefile.PL
  - Minimize prereqs listed in META.json to avoid giving the appearance of XS
    prerequisites, and confusing static inspection tools such as metacpan.org

* Mon Sep 12 2016 Paul Howarth <paul@city-fan.org> - 1.003007-1
- Update to 1.003007
  - Bump prereq on JSON::PP, to ensure we get the fix for parsing utf8-encoded
    values
  - We now always upgrade JSON::XS if it is installed and below version 3.0,
    due to changes in handling booleans
  - Remove test dependency on Test::Without::Module (CPAN RT#115394)
- Update patch for building with Test::More < 0.88

* Wed Aug 31 2016 Paul Howarth <paul@city-fan.org> - 1.003005-5
- BR: perl-generators where available
- Simplify find command using -delete

* Wed Jun 24 2015 Paul Howarth <paul@city-fan.org> - 1.003005-3
- Perl 5.22 rebuild

* Mon Mar 23 2015 Paul Howarth <paul@city-fan.org> - 1.003005-1
- Update to 1.003005
  - Fix x_contributors metadata that was killing metacpan (see
    https://github.com/CPAN-API/cpan-api/issues/401)

* Sun Mar 15 2015 Paul Howarth <paul@city-fan.org> - 1.003004-1
- Update to 1.003004
  - Caveat added to documentation about type checking the object returned by
    new() (CPAN RT#102733)
- Update patch for building with Test::More < 0.88

* Mon Dec  8 2014 Paul Howarth <paul@city-fan.org> - 1.003003-1
- Update to 1.003003
  - Ensure an old Cpanel::JSON::XS is upgraded if it is too old, as it will
    always be used in preference to JSON::XS
  - Avoid "JSON::XS::Boolean::* redefined" warnings caused by an old JSON::XS
    loaded at the same time as a newer Cpanel::JSON::XS

* Sun Nov 16 2014 Paul Howarth <paul@city-fan.org> - 1.003002-1
- Update to 1.003002
  - Correctly fix boolean interoperability with older Cpanel::JSON::MaybeXS

* Thu Nov 13 2014 Paul Howarth <paul@city-fan.org> - 1.003001-1
- Update to 1.003001
  - Add :legacy tag to support legacy apps
  - Fix boolean interoperability with older Cpanel::JSON::MaybeXS
- Update patch for building with Test::More < 0.88

* Wed Oct 22 2014 Paul Howarth <paul@city-fan.org> - 1.002006-1
- Update to 1.002006
  - Add some additional test diagnostics, to help find bad version combinations
    of JSON backends
- Update patch for building with Test::More < 0.88
- Add patch for building with Test::More < 0.82

* Wed Oct 15 2014 Paul Howarth <paul@city-fan.org> - 1.002005-1
- Update to 1.002005
  - Fix "can I haz XS?" logic precedence in Makefile.PL
  - Added the ':all' export tag
  - Removed dependency on Safe::Isa
  - Repository moved to git://git.shadowcat.co.uk/p5sagit/JSON-MaybeXS.git

* Sun Oct 12 2014 Paul Howarth <paul@city-fan.org> - 1.002004-1
- Update to 1.002004
  - Support use of PUREPERL_ONLY in Makefile.PL to avoid adding an XS
    dependency
  - New is_bool() interface
- Update patch for building with Test::More < 0.88

* Wed Oct  8 2014 Paul Howarth <paul@city-fan.org> - 1.002003-1
- Update to 1.002003
  - Document how to use booleans

* Wed Sep 17 2014 Paul Howarth <paul@city-fan.org> - 1.002002-4
- Perl 5.20 rebuild

* Thu Apr 24 2014 Paul Howarth <paul@city-fan.org> - 1.002002-1
- Update to 1.002002
  - More metadata fiddling, to remove the Cpanel::JSON::XS dependency visible
    to static analyzers (the prerequisites at install time remain unchanged)

* Wed Apr 23 2014 Paul Howarth <paul@city-fan.org> - 1.002001-1
- Update to 1.002001
  - Fix installation on older perls with an older ExtUtils::MakeMaker
    (CPAN RT#94964)
- Update patch for building with Test::More < 0.88

* Wed Apr 23 2014 Paul Howarth <paul@city-fan.org> - 1.002000-1
- Initial RPM version
